package gettextdemo;

import java.text.MessageFormat;
import java.util.Locale;
import java.util.ResourceBundle;
import java.util.MissingResourceException;

public class GetTextDemo
{
	public static void main(String args[]) 
	{
		GetTextDemo demo = new GetTextDemo();

		System.out.println("Output for English.");
		Locale.setDefault(new Locale("en","US"));
		demo.run();

		System.out.println();

		System.out.println("Output for Spanish.");
		Locale.setDefault(new Locale("es","ES"));
		demo.run();

		System.out.println();

		System.out.println("Output for Thai.");
		Locale.setDefault(new Locale("th","TH"));
		demo.run();
	}

	public void run()
	{

		System.out.println(new Translator("An English message"));

		Object messageParts[] = new Object[2];
		messageParts[0] = new Integer(3);
		messageParts[1] = "hello";
		System.out.println(new Translator("a {0} b {1} c", messageParts));
	}

}

class Translator
{
	private String formattedMessage;

	public Translator(String message)
	{
		this(message, (Object [])null);
	}

	public Translator(String message, Object args[])
	{
		String translatedMessage;
		try {
			ResourceBundle bundle = ResourceBundle.getBundle("gettextdemo.messages");
			translatedMessage = bundle.getString(message);
		}
		catch (MissingResourceException mre)
		{
			translatedMessage = message;
		}

		if (translatedMessage != null && args != null) {
			formattedMessage = MessageFormat.format(translatedMessage,args);
		}
		else
		{
			formattedMessage = translatedMessage;
		}
	}


	public String toString()
	{
		return formattedMessage;
	}
}

